<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>iQuestFactory Struct Reference (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">iQuestFactory Struct Reference</div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="iQuestFactory" --><!-- doxytag: inherits="iBase" -->
<p>A quest factory.  
 <a href="structiQuestFactory.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="questmanager_8h_source.html">tools/questmanager.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for iQuestFactory:</div>
<div class="dyncontent">
 <div class="center">
  <img src="structiQuestFactory.png" usemap="#iQuestFactory_map" alt=""/>
  <map id="iQuestFactory_map" name="iQuestFactory_map">
<area doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html" alt="iBase" shape="rect" coords="0,0,92,24"/>
</map>
 </div></div>

<p><a href="structiQuestFactory-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiQuestFactory.html#a4d3d113c935c72dfc05c9f7792df47d9">ClearDefaultParameters</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Clear all default parameters on this factory.  <a href="#a4d3d113c935c72dfc05c9f7792df47d9"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr</a>&lt; <a class="el" href="structiQuest.html">iQuest</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiQuestFactory.html#ab363958672c2b9769cbeac94d5a5cb6d">CreateQuest</a> (const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsHash.html">celParams</a> &amp;params)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Instantiate a quest from this factory.  <a href="#ab363958672c2b9769cbeac94d5a5cb6d"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="structiCelSequenceFactory.html">iCelSequenceFactory</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiQuestFactory.html#a0e9bc9b1c924ffb6bddedd66894f72a8">CreateSequence</a> (const char *name)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Create a new sequence factory in this factory.  <a href="#a0e9bc9b1c924ffb6bddedd66894f72a8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="structiQuestStateFactory.html">iQuestStateFactory</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiQuestFactory.html#a960b6ec97500d48d75ba8d919fb0b529">CreateState</a> (const char *name)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Create a new state in this factory.  <a href="#a960b6ec97500d48d75ba8d919fb0b529"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual const char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiQuestFactory.html#af22c6a77b9de8bd7f8a01bbc417774e0">GetDefaultParameter</a> (const char *name) const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get a default parameter from this factory.  <a href="#af22c6a77b9de8bd7f8a01bbc417774e0"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual const char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiQuestFactory.html#af3d926a780a0677086af3196e82b0839">GetName</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the name of this factory.  <a href="#af3d926a780a0677086af3196e82b0839"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="structiCelSequenceFactory.html">iCelSequenceFactory</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiQuestFactory.html#a2b1408d4242a13d1e72fd141475c97b4">GetSequence</a> (const char *name)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get a sequence factory in this factory.  <a href="#a2b1408d4242a13d1e72fd141475c97b4"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="structiQuestStateFactory.html">iQuestStateFactory</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiQuestFactory.html#a248644bd1b83411535d981b2a9f03f36">GetState</a> (const char *name)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get a state from this factory.  <a href="#a248644bd1b83411535d981b2a9f03f36"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiQuestFactory.html#a2e3fc4a12068bf3834b195551346d9b3">Load</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiDocumentNode.html">iDocumentNode</a> *node)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Load this factory from a document node.  <a href="#a2e3fc4a12068bf3834b195551346d9b3"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiQuestFactory.html#a52758c7e8fea9d266406b072b0952e1a">SetDefaultParameter</a> (const char *name, const char *value)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Set a default parameter on this factory.  <a href="#a52758c7e8fea9d266406b072b0952e1a"></a><br/></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>A quest factory. </p>
<p>A quest factory is a template to create a quest from. All interfaces ending with 'Factory' are relevant in the concept of a quest factory. </p>
<ul>
<li>
A quest factory is made out of a number of quest state factories (<a class="el" href="structiQuestStateFactory.html" title="A representation of a quest state in a quest factory.">iQuestStateFactory</a>) (from which the states in the quest are made). </li>
<li>
Every quest state factory has one or more trigger response factories. These response factories describe how the firing of one trigger (as described by a trigger factory) can cause a number of rewards (as described by reward factories). </li>
</ul>

<p>Definition at line <a class="el" href="questmanager_8h_source.html#l00150">150</a> of file <a class="el" href="questmanager_8h_source.html">questmanager.h</a>.</p>
</div><hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a4d3d113c935c72dfc05c9f7792df47d9"></a><!-- doxytag: member="iQuestFactory::ClearDefaultParameters" ref="a4d3d113c935c72dfc05c9f7792df47d9" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiQuestFactory.html#a4d3d113c935c72dfc05c9f7792df47d9">iQuestFactory::ClearDefaultParameters</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Clear all default parameters on this factory. </p>

</div>
</div>
<a class="anchor" id="ab363958672c2b9769cbeac94d5a5cb6d"></a><!-- doxytag: member="iQuestFactory::CreateQuest" ref="ab363958672c2b9769cbeac94d5a5cb6d" args="(const celParams &amp;params)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr</a>&lt;<a class="el" href="structiQuest.html">iQuest</a>&gt; <a class="el" href="structiQuestFactory.html#ab363958672c2b9769cbeac94d5a5cb6d">iQuestFactory::CreateQuest</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsHash.html">celParams</a> &amp;&#160;</td>
          <td class="paramname"><em>params</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Instantiate a quest from this factory. </p>
<p>This instance will have the same structure as this factory but it will be made out of non-factory objects (iQuestTrigger, iQuestReward, ...). </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">params</td><td>are the parameters with which this quest is instantiated. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a0e9bc9b1c924ffb6bddedd66894f72a8"></a><!-- doxytag: member="iQuestFactory::CreateSequence" ref="a0e9bc9b1c924ffb6bddedd66894f72a8" args="(const char *name)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="structiCelSequenceFactory.html">iCelSequenceFactory</a>* <a class="el" href="structiQuestFactory.html#a0e9bc9b1c924ffb6bddedd66894f72a8">iQuestFactory::CreateSequence</a> </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>name</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Create a new sequence factory in this factory. </p>
<p>Return 0 on failure (name already exists). </p>

</div>
</div>
<a class="anchor" id="a960b6ec97500d48d75ba8d919fb0b529"></a><!-- doxytag: member="iQuestFactory::CreateState" ref="a960b6ec97500d48d75ba8d919fb0b529" args="(const char *name)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="structiQuestStateFactory.html">iQuestStateFactory</a>* <a class="el" href="structiQuestFactory.html#a960b6ec97500d48d75ba8d919fb0b529">iQuestFactory::CreateState</a> </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>name</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Create a new state in this factory. </p>
<p>Return 0 on failure (name already exists). </p>

</div>
</div>
<a class="anchor" id="af22c6a77b9de8bd7f8a01bbc417774e0"></a><!-- doxytag: member="iQuestFactory::GetDefaultParameter" ref="af22c6a77b9de8bd7f8a01bbc417774e0" args="(const char *name) const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const char* <a class="el" href="structiQuestFactory.html#af22c6a77b9de8bd7f8a01bbc417774e0">iQuestFactory::GetDefaultParameter</a> </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>name</em></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get a default parameter from this factory. </p>
<p>Return 0 if the parameter does not exist. </p>

</div>
</div>
<a class="anchor" id="af3d926a780a0677086af3196e82b0839"></a><!-- doxytag: member="iQuestFactory::GetName" ref="af3d926a780a0677086af3196e82b0839" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const char* <a class="el" href="structiQuestFactory.html#af3d926a780a0677086af3196e82b0839">iQuestFactory::GetName</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the name of this factory. </p>

</div>
</div>
<a class="anchor" id="a2b1408d4242a13d1e72fd141475c97b4"></a><!-- doxytag: member="iQuestFactory::GetSequence" ref="a2b1408d4242a13d1e72fd141475c97b4" args="(const char *name)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="structiCelSequenceFactory.html">iCelSequenceFactory</a>* <a class="el" href="structiQuestFactory.html#a2b1408d4242a13d1e72fd141475c97b4">iQuestFactory::GetSequence</a> </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>name</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get a sequence factory in this factory. </p>
<p>Return 0 if the factory doesn't exist. </p>

</div>
</div>
<a class="anchor" id="a248644bd1b83411535d981b2a9f03f36"></a><!-- doxytag: member="iQuestFactory::GetState" ref="a248644bd1b83411535d981b2a9f03f36" args="(const char *name)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="structiQuestStateFactory.html">iQuestStateFactory</a>* <a class="el" href="structiQuestFactory.html#a248644bd1b83411535d981b2a9f03f36">iQuestFactory::GetState</a> </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>name</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get a state from this factory. </p>
<p>Return 0 if the state doesn't exist. </p>

</div>
</div>
<a class="anchor" id="a2e3fc4a12068bf3834b195551346d9b3"></a><!-- doxytag: member="iQuestFactory::Load" ref="a2e3fc4a12068bf3834b195551346d9b3" args="(iDocumentNode *node)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiQuestFactory.html#a2e3fc4a12068bf3834b195551346d9b3">iQuestFactory::Load</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiDocumentNode.html">iDocumentNode</a> *&#160;</td>
          <td class="paramname"><em>node</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Load this factory from a document node. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">node</td><td>is the &lt;quest&gt; node. </td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>false on error (reporter is used to report). </dd></dl>

</div>
</div>
<a class="anchor" id="a52758c7e8fea9d266406b072b0952e1a"></a><!-- doxytag: member="iQuestFactory::SetDefaultParameter" ref="a52758c7e8fea9d266406b072b0952e1a" args="(const char *name, const char *value)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiQuestFactory.html#a52758c7e8fea9d266406b072b0952e1a">iQuestFactory::SetDefaultParameter</a> </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>value</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set a default parameter on this factory. </p>
<p>If the parameter exists it will be overwritten. </p>

</div>
</div>
<hr/>The documentation for this struct was generated from the following file:<ul>
<li>tools/<a class="el" href="questmanager_8h_source.html">questmanager.h</a></li>
</ul>
</div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
